<?php
include_once 'path.php';
if(!isset($_SESSION['validUser']) || $_SESSION['validUser'] !== true)
	exit(header("Location:../index.php"));

$hostName = Scheduler::GetHost($userName);

if($_SESSION['dedup']){
	$nickNameExists = empty($hostName)?false:true;
	$deviceIDExists = deviceIDExists();
}

$jobs = Scheduler::ReadJobs();
$cancellingBackupJob=false;

$startPidfilePath = Scheduler::$backup_dir."+ManualTask/".START_PID;
$userCancelPath = Scheduler::$backup_dir."+ManualTask/".CANCEL_PATH;
	
if(file_exists($startPidfilePath)){
	if(file_exists($userCancelPath)){
		$currentBackupJob = 0;	
		$cancellingBackupJob=true;		
	} else {
		$currentBackupJob = 0;
	}
} else {
	$currentBackupJob = '';	
}	

$currentLocalBackupJob = '';
$localBKPpidPath = Scheduler::$localbackup_dir . Scheduler::$manual_dir . '/' . START_PID;
if(file_exists($localBKPpidPath)) {
	$currentLocalBackupJob = 0;	
}

$_SESSION['currentBackupJob']=$currentBackupJob;			

if(!isset($_SESSION['showHidden'])){
	checkShowHidden();
}

?>

<script>
	if(typeof(IDrive.Jobs) == "undefined") {
		IDrive.Jobs = <?php echo json_encode($jobs);?>;
		if(currentBackupJob == '<?php print DEFAULT_BACKUPSET_NAME;?>') {
			var isDefaultBackupSet  = '<?php print count($jobs[DEFAULT_BACKUPSET_NAME]); ?>';
			if(isDefaultBackupSet <= 0) {
				currentBackupJob = '';
			}
		}
	}
    dedup = <?php print ($_SESSION['dedup'])?"true;":"false;"; ?>
    //dedupDeviceId = <?php print ($_SESSION['dedup'])?"'".$_SESSION['deviceID']."'":"null;" ?>;
	currentDedupDeviceId = <?php print ($_SESSION['dedup'])?"'".$_SESSION['deviceID']."'":"null;" ?>;
	
	manualLocalBackupRunning = <?php echo (($currentLocalBackupJob === 0)? 'true' : 'false'); ?>;
</script>
 <div id="rgt" class="serverDts " style="height: 591px; right: -800px;">   
  <span class="closeIcon"> <img class="right closeWin" src="include/images/popup_close_btn.png"></span> 
  <h4>Search</h4>
  <div class="search_box">
    <!-- <form onsubmit="return false;" name="search_box_inpt"> -->
	<input type="text" placeholder="Search file/folder" title="Search" value="" class="search_box_inpt search_input">
	<div style="display: none;" class="head_srch_item"> <span>Contacts</span> </div>
	<input type="submit" class="search_box_btn" id="localSearch" value="Search">
	<span style="display:block;" class="disabled_search_btn">Search</span>
	<section class="locationWrapper">
		<div class="locationMain"><span>Location</span>:&nbsp;<span id="location_selected">/</span></div>
	</section>
	  <!-- <input type="submit" class="search_box_btn" id="search_home" value="Search"> -->
    <!-- </form> -->
  </div>
  <div class="clear"></div>
	<div id="searchError" class="common_msg">
		<p>Please enter the keyword</p>
		<a class="close_info" href="javascript:void(0)">
			<img width="16" height="16" src="include/images/close.png" alt="close" title="Close">
		</a> 
	</div> 
	<div class="common_msg welcome_message" id="exlude_resultmsg" style="display: none;">
	 <p></p>
	 <a class="close_info" href="javascript:void(0)"><img width="16" height="16" src="include/images/close.png" alt="close" title="Close"></a>
  </div>

  <div class="currentLoad">
   <div style="display: none;" id="lazyLoadingImg" class="pageLoaderbtm"></div>
   <!-- <div class="center popLoader"><img src="include/images/loader_small.gif"></div>-->
    <section class="menu">
      <div class="left_menu">
       </div>
      <div id="rightMenu" class="right_menu"> 
        <div class="addbckupset" id="addToBackupSet"><a alt="" href="javascript:void(0)" class="bckp_img">Add to backup set</a></div> 
      </div>
    </section>
    <div class="exclude">
      <div class="excludeContainer searchSection">
		<div  class="tab_loader"><p>loader...</p></div>
        <div style="border:none" class="selected_bdr" id="localDirSearchListWrapper">
          <table id="localDirSearchHeader" cellspacing="0" cellpadding="0" border="0" width="100%" class="folderBackupContent">
            <tbody>
              <tr class="excludeheader header_part ">
                <td class="file_check search-chk-box">&nbsp;&nbsp;&nbsp;&nbsp;
					<!-- <input type="checkbox" class="checkcontrol" id="mainchek">
					<label class="" >All</label> -->
				</td>
                <td class="search-file-name">File / Folder name</td>
                <td class="search-file-size">Size</td>
                <td class="search-file-date">Date modified</td>
                <td class="search-menu-icon">&nbsp;</td>				
              </tr>
            </tbody>
          </table>
          <div class="ajax_loader"></div>
          <div class="nfiles">No Results</div>
          <div id="localDirSearchList" style="overflow: auto;" class="excludefiles">
            <table cellspacing="0" cellpadding="0" border="0" width="100%" class="folderBackupContent selectedFiles_tab backupset_table bc_table">
              <tbody>
                 <!-- Search Result will be here -->      
              </tbody>
            </table>
          </div>
        </div>
        <!-- selected_bdr --> 
      </div>
    </div>
  </div>
</div>
<div class="container body_wrap backup_page">
<div class="ajax_loader"><p>loader...</p></div>
<section class="breadcrum_menu menu_wrap">
	<div id="fullPathBreadCrumb" class="breadcrumb"><a href="javascript:void(0);" alt="/" class="getDirList home">Home</a></div>
	<div class="menu_refresh_icon" title="Refresh your backup list">Refresh</div>
</section>
<section class="menu backup_menu">
    <div class="option_heading">    	
        <div class="right_w">         
        </div>
    </div>
    <div class="msg_option">    
    	<div class="option_msg">
        	<div class="heading_option">Options</div>
            <div class="close_menu"><img src="include/images/popup_close_btn.png"></div> 
        </div>
    </div>
      <div class="left_menu">
             <li style="display:none" class="delete_li"><a alt="" data-tooltip="Delete" href="javascript:void(0)" class="menu_delete">Delete</a></li>
        </div>
      <div class="right_menu">
        <div class="backupset" title="Create new Backup set"><img src="include/images/idq_ico_add.png">Create new Backup set</div>
        <div class="search_menu" title="Search"><img src="include/images/search_icon.png">Search</div>
		<?php 
		/*checking path mirror / relative */
		if(getBackupMode() != 'relative'){
		?>
        <div class="archive_menu" title="<?php echo ARCHIVECLEANUP_TITLE; ?>"><img src="include/images/idrive_archiveCleanup.png" ><?php echo ARCHIVECLEANUP_TITLE; ?></div> 
        <?php }?>
      </div>
    </section>
<div class="exclude restorset_top">
  <div class="excludeContainer backupFilePath">
    <table width="100%" border="0"  cellpadding="0" cellspacing="0">
      <tr class="excludeheader header_part backexcludeheader">
        <td class="file_check">
          <input type="checkbox" id="maincheck" class="checkcontrol">
          <label class="mainCheck">All</label>
        </td>
        <td class="fname cont_heading">File/Folder name</td>
        <td class="file_size">Size</td>
        <td class="file_date">Date modified</td>
		<!-- <td class="file_menu_list_head"></td> -->
      </tr>
    </table>
    <div class="nfiles"><?php print NO_FILES;?></div>
	<!-- <div class="ajax_loader"><p>loader...</p></div> -->
    <div id="loadFullPath">   
	<div class="excludefiles" style="overflow: hidden;">
	  <table id="excludeFilesPath" width="100%" border="0" cellspacing="0" cellpadding="0" class="folderBackupContent backupset_table bc_table">
		<tbody></tbody>
	  </table>
	</div>
    </div>
  </div>
</div>
<div id="backupset_list" class="exclude clear_margin restore_set">
  <div class="excludeContainer">
    <table width="100%" border="0" cellpadding="0" cellspacing="0" class="main_chk_table1">
      <tr class="excludeheader backupsetTitle ">
		<?php /*Machine Based list*/backupJobList($jobs,'backup');  ?>
      </tr>
    </table>
    <table width="100%" border="0" cellpadding="0" cellspacing="0" class="main_chk_table">
      <tr class="excludeheader header_part" style="display:none;">
        <td class="file_check">
          <input type="checkbox" id="maincheckBackup" class="checkcontrol">
          <label class="mainCheck">All</label>
        </td>
        <td class="fname" width="37%">File/Folder name</td>
        <td width="14%">&nbsp;</td>
        <td width="25%" id="removebBackupsetFiles" class="backupset_chk_delete" align="right"> <span> Remove </span></td>
      </tr>
    </table>
    <div class="nfiles" id="noBackupsetFiles" style="display:block;"><?php print NO_BACKUPSET_FILES;?></div>
	<div class="ajax_loader"><p>loader...</p></div>
    <form id="startBackupForm" name="startBackupForm" method="POST">
	<input type="hidden" name="jobTypeManualTask" value="Backup" />
	<input type="hidden" name="oldJobName" id="oldJobName" value="<?php print $currentBackupJob!=''?$currentBackupJob:'0'; ?>" />
     <div class="excludefiles scheduler_part" style="display:none;">       
      <table id="backupsetFiles" width="100%" cellspacing="0" cellpadding="0" border="0" class="folderBackupContent">
        <!-- backup set Files needs to be added -->
      </table>      
     </div>    
    <div class="restorenow_btm">
		<div class="folder_capacity">
           		    <p><span class="sizeLoadingIcon"></span>Size of the files / folders selected for backup: <span id="backupSetSizeHTML">0.00 B</span></p>
            <div class="clear"></div>
			<input type="hidden" value="0" id="backupSetSize">
        </div>		
      <div class="restorenow_lft">
        <label>Backup location:</label>    
		<?php if($_SESSION['dedup']){ ?>
			<input type="textbox" id="backupLocation" onblur="backupLocationChange()" onclick="backupLocationDedupClick()" name="backupLocation" style="color:#000;" value="<?php echo htmlentities($hostName, ENT_QUOTES) ?>" maxlength="64" title="<?php echo htmlentities($hostName, ENT_QUOTES) ?>" onpaste="return false;" />	
		<?php } else { ?>
			<input type="textbox" id="backupLocation" name="backupLocation" class="restore_txtbox" readonly="" title="<?php echo htmlentities($hostName, ENT_QUOTES) ?>" value="<?php echo htmlentities($hostName, ENT_QUOTES) ?>">	
			<input type="button" id="file_browse" value="...">		
		<?php } ?>
      </div>
      <div class="restorenow_rgt">
	<input type="hidden" id="startManualTaskButton" name="startManualTaskButton" />
	<input type="hidden" id="cancelManualTaskButton" name="cancelManualTaskButton" />
	<?php
		if($cancellingBackupJob==true){
			$cancellingJob   = 'style="display:block;"';
			$startJobButton  = 'style="display:none;"';
			$cancelJobButton = 'style="display:none;"';	
			$cancellingLoader = 'style="display:block;"';
		} else if($currentBackupJob===0){
			$cancellingJob   = 'style="display:none;"';
			$startJobButton  = 'style="display:none;"';
			$cancelJobButton = 'style="display:block;"';
			$cancellingLoader = 'style="display:none;"';
		} else {
			$cancellingJob   = 'style="display:none;"';
			$startJobButton  = 'style="display:block;"';
			$cancelJobButton = 'style="display:none;"';
			$cancellingLoader = 'style="display:none;"';			
		}
    if($machine=='twotier'){	
	?>     
		<input type="submit" class="scheduleBtn" id="startBackup" name="startBackup" value="Backup Now" onClick="return startManualBackup()" <?php print $startJobButton; ?> />
        <div class="stop_bkp">
         <div class="cancel_loading_icon"  <?php print $cancellingLoader; ?>>Loading...</div>
		 <span class="scheduleBtn" id="cancellingBackup"  <?php print $cancellingJob; ?>>Stopping Backup</span>
        </div>
		<input type="submit" class="scheduleBtn" id="cancelBackup" name="cancelBackup" value="Stop Backup" onClick="return cancelManualBackup()"  <?php print $cancelJobButton; ?>  />
		<!-- <div class="loading_icon"  <?php print $cancelJobButton; ?>>Loading...</div>  -->
		<input type="submit" class="scheduleBtn" id="ScheduleBackup" name="cancelBackup" value="<?php echo TWOTIER_SCHEDULER_TITLE; ?>" onClick="return scheduleBackup()"  />	
	<?php } else { ?>
		<!-- <div class="loading_icon" <?php print $cancellingLoader; ?>>Loading...</div> -->
		<input type="submit" class="scheduleBtn" id="startBackup" name="startBackup" value="Backup Now" onClick="return startManualBackup()" <?php print $startJobButton; ?> />
		<div class="stop_bkp">
			<div class="cancel_loading_icon" style="display:none;">Loading...</div>
			<span class="scheduleBtn" id="cancellingBackup" style="display:none;">Stopping Backup</span>
		</div>
		<input type="submit" class="scheduleBtn" id="cancelBackup" name="cancelBackup" value="Stop Backup" onClick="return cancelManualBackup()"  <?php print $cancelJobButton; ?> />
    <?php } ?>  
      </div>
    </div>
    </form>
  </div>
  <!-- End excludeContainer -->
</div>
<!-- End exclude -->
<!--q napschedule_container starts Schedule job popup-->

<div id="scheduler_div" class="popup_container qnapschedule_container popLeft" >
<form name="frm_update_schedule" id="frm_update_schedule" method="post" >
  <section class="popup_header">
    <h4>Schedule backup parameters</h4>
    <span class="popup_close_btn hide_popup" title="Close"></span>
  </section>
  <section class="popup_body">       
	<div id="popupError" class="common_msg">
		<p><?php print INVALID_EMAIL; ?></p>
		<a class="close_info" href="javascript:void(0)">
			<img width="16" height="16" src="include/images/close.png" alt="close" title="Close">
		</a> 
    </div>
    <?php 
	//Backup Scheduler
	$curPage = 'backup';
	include('scheduleDiv.php');
    ?> 
   
  </section>
  <section class="popup_footer">
    <input type="button" id="update_scheduler" name="update_scheduler" class="addButton" value="Update Schedule">
    <input type="button" class="scheduleBtn popup_cancelBtn" value="Cancel" >
  </section>
</form>
</div>

<!--popup starts New Backup set-->
<div class="popup_container popContent newBkpSet popLeft">
 <section class="popup_header">
  <h4>Create new Backup set</h4>
  <span class="popup_close_btn hide_popup"></span>
 </section>
 <section class="popup_body">
  <div id="popupError1" class="common_msg">
	<p>Please select folder/file to backup</p>
	<a class="close_info" href="javascript:void(0)">
		<img width="16" height="16" src="include/images/close.png" alt="close" title="Close">
	</a> 
  </div>
  <div class="setname">Backup Set Name &nbsp; <input type="text" class="backupsetInput" name="newJobName" id="newJobName" maxlength="50" /> </div>
  <div class="exclude popup_set_exclude">
   <div class="excludeContainer newBackupSetClass">
  <!-- files table -->
 <table width="100%" border="0"  cellpadding="0" cellspacing="0" height="40">
        <tr class="popup_tabs" id="backupTab">
          <td  width="30%" class="selected_before active" >Files/Folders for backup </td>
          <td width="30%" class="selected_after" >Selected files/folders list</td>
          <td width="20%" class="selected_empty"> </td>
          <td width="20%" class="selected_empty"></td>
        </tr>
      </table>
  <div id="selectFiles" class="exclude popup_set_exclude" style="margin-top:0px">
    <div class="excludeContainer backup_page">     
      <div class="selected_bdr">
        <div class="breadcrumb" id="bkpBreadCrumb"><a href="javascript:void(0);" alt="/">/</a></div>
        <table width="100%" border="0"  cellpadding="0" cellspacing="0" class="folderBackupContent selectedFiles_tab">
          <tr class="excludeheader header_part bckheader">
            <td class="file_check"> <input type="checkbox" id="maincheck" class="checkcontrol"> <label class="mainCheck">All</label> </td>
			<td class="fname cont_heading">File/Folder name</td>
			<td class="file_size">Size</td>
			<td class="file_date">Date modified</td>
          </tr>
        </table>
        <div class="ajax_loader"><p>loader...</p></div>
        <div class="nfiles"><?php print NO_FILES;?></div>
        <div id="newBackupSet">
		  <div style="overflow: hidden;" class="excludefiles">
			 <table width="100%" cellspacing="0" cellpadding="0" border="0" class="folderBackupContent backupset_table" id="excludeFilesPath">
			   <tbody></tbody>
			 </table>
		  </div>
        </div>
      </div>  
        </div>
      </div> 
  <div id="selectedFiles" class="exclude popup_set_exclude" style="margin-top:0px; display:none;">
    <div class="excludeContainer"> 
	<!-- Selected Folders/Files - Start -->	  
 	<div class="selected_bdr" >
	    <table width="100%" border="0" cellpadding="0" cellspacing="0" class="main_chk_table folderBackupContent" style="display:none;">
	      <tr class="excludeheader header_part">
		<td class="file_check">
		  <input type="checkbox" id="maincheckSelected" class="checkcontrol">
		  <label class="mainCheck">All</label>
		</td>
		<td class="fname" width="37%">File/Folder name</td>
		<td width="24%">&nbsp;</td>
		<td width="15%" id="removeSelectedFiles" class="backupset_chk_delete" align="right"> <span style="display: none;"> Remove </span></td>
	      </tr>
	    </table>
	    <div class="nfiles"><?php print NO_BACKUPSET_FILES;?></div>
            <div class="excludefiles selected_items">
	    <form id="newBackupSetForm" method="POST"><input type="hidden" name="jobType" value="Backup" />
      	    <table id="selectedBackupsetFiles" width="100%" cellspacing="0" cellpadding="0" border="0" class="folderBackupContent">
        	<!-- Folders/Files needs to be added-->	
      	    </table>
	    </form>
          </div>
   	 </div>
	 <!-- Selected Folders/Files -->    
    </div>
  </div>
  <!-- End file table -->
    </div>
  </div>
  <div class="clear"></div>
  </section>
  <section class="popup_footer">
  <div class="btncontainer">	
    <input type="submit" class="addButton" id="schedule_backup" value="<?php echo TWOTIER_SCHEDULER_TITLE; ?>" >
    <input type="submit" class="scheduleBtn popup_cancelBtn" value="Cancel" >
  </div>
  </section>
</div>
<!--popup starts Add Folders/Files to your exclude list -->
<div class="popup_container popContent Backuplocation_popup popLeft backup_page">
 <section class="popup_header">   
  <h4>Select your backup location</h4>
  <span class="popup_close_btn hide_popup"></span>
 </section>
 <section class="popup_body">
	<div class="common_msg" id="permissionError" style="display: none;">
		<p>Error Message Here</p>
		<a href="javascript:void(0)" class="close_info">
			<img width="16" height="16" title="Close" alt="close" src="include/images/close.png">
		</a> 
	</div>
  <!-- files table -->
  <div class="exclude popup_set_exclude">
    <div class="excludeContainer">
      <div id="backupLocationBreadCrumb" class="breadcrumb"><a href="javascript:void(0);" alt="/" class="getBackupDirList">/</a></div>
      <table width="100%" border="0" cellpadding="0" cellspacing="0" class="folderBackupContent">
        <tbody>
          <tr class="excludeheader header_part ">
            <td class="cont_heading" width="100%">File/Folder name</td>
           
          </tr>
        </tbody>
      </table>
      <div class="ajax_loader"><p>loader...</p></div>
      <div class="nfiles"><?php print NO_FILES;?></div>
	    <!-- Load Folders/Files from Disk - Start -->
	    <div id="loadBackupLocation"><!-- Display Folders Here -->
	    </div> 
	    <!-- Load Folders/Files from Disk - End -->
    </div>
  </div>
  <!-- End file table -->
  <div class="clear"></div>
 </section>
 <section class="popup_footer">
  <div class="btncontainer">
    <input type="submit" id="addBackupLocation" class="scheduleBtn" value=" Ok ">
    <input type="submit" class="scheduleBtn popup_cancelBtn" value="Cancel">
  </div>
 </section>
</div>
</div>
<!-- Start-------------------------------------- - -------------Archive Cleanup popup---------------------------------------------------------------------------------------->
<input type="hidden" name="actiontype" id="actiontype" value=""/>
<input type="hidden" name="archiveWindow" id="archiveWindow" value=""/>

<div class="popup_container archive_cleanup_popup" style="display:none;">
<div id="ajaxLoaderForPercError" class="ajax_loader" style="display: none;"></div>
	<section class="popup_header">
		<h4><?php echo ARCHIVECLEANUP_TITLE; ?> <span id="archiveCleanupJobName"></span></h4>
		<span class="popup_close_btn hide_popup" id="archiveMainpopup"></span> 
	</section>
	
	<section class="popup_body">
	
    <div style="display: none;" class="common_msg welcome_message" id="archiveerror">
      <p id="cleanupstop"></p>
      <a class="close_info" href="#"> <img width="16" height="16" src="include/images/close.png" alt="close" title="Close"> </a> 
    </div>
	<!---hidden values for periodic---->
	<input type="hidden" name="currentperiodicPerc" id="currentperiodicPerc" value=""/>
	<input type="hidden" name="currentperiodicDays" id="currentperiodicDays" value=""/>
	
    <div class="setname">WARNING: Archive Cleanup permanently deletes data which no longer exists on your computer to free up space in your account. Specifically, Archive Cleanup makes a one to one match of the local data in the backup set selected for Archive Cleanup.    <span class="know-more-click">[Know more]</span></div>
    <div class="cleanup-know-more">
      <span class="know_more_close_btn"></span>
      <p>We prevent the cleanup process when the number of files considered for cleanup is more than a certain percentage of the total number of files in your backup set. This is done to avoid inadvertent data loss in case of an unexpected event on your computer. For 'Cleanup Now', this percentage is set to 25% by default.</p>
      <p>For 'Periodic Cleanup', we give you more control by allowing you to set the frequency as well as the percentage of files to be considered. The frequency can be set to anything between 10 and 30 days and percentage to anything between 5 and 25%.</p>
      <p>For example: If frequency is set to 20, your cleanup will be performed after every 20 days, If percentage is set to 10% and if the number of files for cleanup are more than 10% of the total number of files in your backup set, then the cleanup will not occur.</p>
    </div>
    <div class="cleanup-wrap">
      <div class="cleanup-lft">
        <input type="button" class="cleanup-now" value="Cleanup Now" name="Cleanup Now" id="Cleanup" style="display:block;"/>
		<input type="button" class="stop-cleanup" value="Stop" id="Stop" name="Stop Cleanup"  style="display:none;width:140px;">
		
      </div>
      <div class="cleanup-rgt">
          <div style="display:block;" class="cleanup-value">
            <span>Consider</span>
            <select name="arch_perc" id="arch_perc" class="cleanup-consider">
              <?php for($i=1;$i<=100;$i++){?>
					<option value="<?php echo $i;?>" <?php if($i==25)echo 'selected="selected"';?>><?php echo $i;?>%</option>
			 <?php }?>    
            </select>
            <span>of files for cleanup.</span>
          </div>
          <div class="cleanup-file-scan" style="display:none;" >
            <div class="file-scan-wrap">
              <p>Files Scanned: <span id="total_files"></span></p>
              <p class="scanning_wrap">Scanning. . . <span id="file_scanned"></span></p>
            </div>
          </div>
      </div>
    </div>
    <div class="clear"></div>	
  </section>
	<!-- list out popup -->
	 <!--Archive Cleanup Footer-------------------------------------------------------------------------------------------------------> 	
  <section class="popup_footer">
    <div class="prdcontainer">
      <div class="period-cnt"><input type="checkbox" name="periodice_clean" id="periodice_clean" class="period-chkbox" value="1"/> <?php echo AR_PERIODIC; ?></div>
      <div class="select-container">
        <select name="periodic_days" id="periodic_days" class="select-drop-dwn">
		   <?php for($days=5;$days<=30;$days++){?>
		  <option value="<?php echo $days;?>"><?php echo $days; ?></option>
          <?php
		  }?>
        </select>
		Number of days of the month, after which data is automatically cleaned up for your backup set.
      </div>
      <div class="select-container">
        <select name="periodic_perc" id="periodic_perc" class="select-drop-dwn">
		<?php for($perc=5;$perc<=25;$perc++){?>
          <option value="<?php echo $perc;?>"><?php echo $perc;?>%</option>
          <?php
		  }?>
        </select>
         <div class="question-popup">
          <div class="arrow-icon"> </div>
          <p>If the number of files to be cleaned exceeds this percentage of the total number of files in your backup set, the cleanup will not proceed.</p>
        </div>
        <p class="cleanup-quetion-icon">Percentage limit beyond which cleanup will not take place.<span  id ="archiveQuestion" class="question-img"></span></p>
      </div>
    </div>
    </section>
	
</div>

<div class="popup_container nofiles_cleanup_popup" id="deleteSuccess" style="display:none; position: absolute;top: 40%;left: 20%;z-index: 99;" >
  <section class="popup_header">
    <h4>IDrive</h4>
    <!-- <span class="popup_close_btn hide_popup"></span> --> </section>
  <section class="popup_body">
    <div id="poperror">Items deleted successfully.</div>
    <div class="clear"></div>
  </section>
  <section class="popup_footer">
    <div class="btncontainer">
      <input type="submit" class="scheduleBtn" value=" Ok " id="ok_Archive">
    </div>
  </section>
</div>

<!---Archive Cleanup error popup starts here----------------------------->
<div class="popup_container cleanup_operation_cleanup_popup" id="archiveAbortPopup" style="display:none;">
  <section class="popup_header">
    <h4>IDrive</h4>
    <!-- <span class="popup_close_btn hide_popup"></span> --> </section>
  <section class="popup_body">
    <div>
    <p id="errormsg">  </p>
    
    </div>
    <div class="clear"></div>
  </section>
  <section class="popup_footer">
    <div class="btncontainer">
      <input type="button" class="scheduleBtn" value="Ok" id="errorbtn">
    </div>
  </section>
</div>
<!---------------------------Error popup ends here------------------------------------------------------>


<!---------------------------Delete Pop up starts here------------------------------------------------------>
<div class="popup_container archive_folder_cleanup_popup" style="display:none;">
	<div class="ajax_loader" id="ajaxLoaderDeleteConfirm1" style="display:none;"></div> 
  <section class="popup_header">
    <h4><?php echo ARCHIVECLEANUP_TITLE; ?></h4>
    <span class="popup_close_btn hide_popup" id="resultPopupClose"></span> </section>
  <section class="popup_body">
    <div>
    <p>List of files/folders present in your account but not on your local machine, Click the 'Delete' button to delete them permanently from your account. </p>
      <div class="files-folders" id="forDeletion" >
		<div id="ajaxLoaderDeleteConfirm_loader">
			<div class="ajax_loader" ><p>loader...</p></div>
		</div>
        <p id="archiveDeletedData"> </p>
		<div class="archiveLazyLoader"></div>
      </div>
    </div>
    <div class="clear"></div>
  </section>
  <section class="popup_footer">
    <div class="btncontainer">
     <input type="button" class="stop-cleanup" value="Delete" id="delete" style="display:block;"> 
    </div>
  </section>
  
</div>

<!-- Delete Backup files Cleanup popup -->
<div class="popup_container delete_files_cleanup_popup" id="deleteConfirmArchive" style="display:none;">
  <section class="popup_header">
    <h4>IDrive</h4>
    <!-- <span class="popup_close_btn hide_popup"></span> --> </section>
  <section class="popup_body">
    <div>Are you sure you want to delete?</div>
    <div class="clear"></div>
  </section>
  <section class="popup_footer">
    <div class="btncontainer">
      <input type="button" class="scheduleBtn"  value="No" id="No">
      <input type="button"  class="scheduleBtn" value="Yes"  id="yes"style="margin-right:15px;">
    </div>
  </section>
</div>

<div id="archiveCleanUp" class="popup_container archive_deleteing_folder_cleanup_popup" style="display:none;">
<div style="display: none;" class="ajax_loader" id="ajaxLoaderDeleteConfirm"></div>
  <section class="popup_header">
    <h4><?php echo ARCHIVECLEANUP_TITLE; ?></h4>
    <span class="popup_close_btn hide_popup" id="deleteBoxClose" ></span> </section>
  <section class="popup_body">
    <div>
    <p>List of files/folders present in your account but not on your local machine, Click the 'Delete' button to delete them permanently from your account. </p>
      <div class="files-folders" id="deleteValues">
       <p id="archiveResult">
	   </p>
      </div>
    </div>
    <div class="clear"></div>
  </section>
  <section class="popup_footer">
    <div class="btncontainer">
      <span class="deleting" id="Deleting">Deleting...</span>
      <input type="submit" class="stop-cleanup" id="deleteCancel"  value="Cancel">
    </div>
  </section>
</div>

<!-- End --------- Archive Cleanup popup ---------------------->

<ul class="dropdown row_dropdown bkp_dropdown jeegoocontext" id="dropdown">
  <!--Added by sajana for Add to exclude list-->
  <li><a class="file_menu_backupset exclude_list">Add to Exclude List</a></li>
  <li><a class="file_menu_refresh refresh_list">Refresh</a></li>
  <li><a class="file_menu_search">Search</a></li>
</ul>
<script type="text/javascript">	
    var localDirMore = true;
	var checkScrolledHeight=0;	
	/* For Search - End*/
	actionRequired=0;
	jQuery(document).ready(function(){
		<?php $status = isRootLevelDisplayEnabled(); if($status == 0){ $rootVal = getRootVal(); } else { $rootVal ="/"; }  echo "updateRootLevelDisplaySettings(" . $status .",\"". $rootVal . "\");";?>
		jQuery('.backup_page .ajax_loader').show();
		var backupSetval = $("#select_job").val();
		if(backupModeSet==null){ backupModeSet = '<?php print getBackupMode();?>'; }
		if(backupSetval == "0" || backupModeSet=='relative'){$(".archive_menu").hide();}
		else{$(".archive_menu").show();}	
	   
		//Added for right menu issue
		var dropdownHTML = jQuery('#dropdown').detach();
		dropdownHTML.appendTo("body");		
		onScrollForLocal(); // For Search
<?php 
	if($currentBackupJob===0){
?>
		loadExistingJob('0','backup');
		watchBackupStatus('backup');
<?php 
	} else {
?>	
		//Deleting the element from Remote Dir List array after Backup
		if(currentBackupLocation!=''){
			var index = dynamicRemoteArray[currentBackupLocation];
			if(index!='undefined' || index!=''){
				delete dynamicRemoteArray[currentBackupLocation];
				delete dynamicRemoteType[currentBackupLocation];
				delete dynamicRemoteSize[currentBackupLocation];
				delete dynamicRemoteDate[currentBackupLocation];
				delete dynamicRemoteRequestInfo[currentBackupLocation];
				currentBackupLocation='';
			}					
		}
		isDefaultBackupSet = parseInt(isDefaultBackupSet);
		
		if(manualBackupRunning==true){
			manualBackupRunning=false;
			defaultBackupSetArray = [];
			defaultBackupSetTypeArray = [];
			defaultBackupSetSizeArray = [];
			defaultBackupSetModTimeInfo = [];
			defaultBackupSetFileInfo = [];
		}		
		if(currentBackupJob!=''){
			jQuery('#select_job').val(currentBackupJob);
			currentBackupJob = jQuery('#select_job').val(); //Added by Senthil for the fix If selected job deleted
			loadExistingJob(currentBackupJob,'backup');
			IDrive.Scheduler.selectSchedule(currentBackupJob,'Backup');
			actionRequired=1;
		} else {
			if(machine=='twotier') {
				loadExistingJob(backupSetval,'backup');
			} else {
				loadExistingJob('','backup');
			}
		} 
<?php 
	}
?>
	// Update the backup location if required
	updateBackupLocationValue();
   });  
   function backupLocationDedupClick() {
		actionRequired=2;	   
   }
    var backupLocationChanged = false;
    function backupLocationChange(){
		if(backupLocationChanged == true){
			return true;
		}
		var location  = $("#backupLocation").val();
		location = location.trim();
		var title 	=  $("#backupLocation").attr('title');
		
		if(location==""){			
			$("#backupLocation").val(title);
			backupLocationChanged = false;
			return false;
		}
		if(location!=title){
			showErrorMessages('.head_search .welcome_message',BACKUP_LOCATION_CHANGED);
			$("#backupLocation").attr('title',location);
			backupLocationChanged = true;
		}
    }
</script>
